import java.util.Vector;
import java.util.Hashtable;

/** Collector operator - smart union of multiple children
 *
 * @author Zack Ives
 * @version 1.0
 */


class Collector extends Operator {
    Vector _children;
    Table _table;
    
    // Constructor - provide the children (which should be scans)
    public Collector(Vector children, Hashtable symbolTable) {
        super (((Operator)children.elementAt(0)).variables(), symbolTable);
        _children = children;
        
        String label = "c";
        
        for (int i = 0; i < _children.size(); i++) {
            label += "_";
            label += ((Operator)_children.elementAt(i)).attribs().name();
        }
        _table = new Table(label);
        for (int i = 0; i < ((Operator)_children.elementAt(0)).variables().size(); i++)
            _table.addAttribute(((Operator)_children.elementAt(0)).attribs().getAttribute(i));

        // Map symbol table entries to our symbols
        for (int i = 0; i < _symbols.size(); i++) {
            _symbolTable.put(_symbols.elementAt(i), attribs().name() + "." + _table.getAttribute(i));
        }
    }
    
    // Return the attributes for the operator
    public Table attribs() {
        return _table;
    }
    
    // Return the operator's children
    public Vector children() {
        return _children;
    }
    
    // String version for printing
    public String toString() {
        String temp = "Collector(";
        for (int i = 0; i < _children.size(); i++) {
            if (i > 0)
                temp += ", ";
            temp += ((Operator)children().elementAt(i)).toString();
        }
        return temp + ")";
    }
}