import java.util.Vector;
import java.util.Hashtable;

/** Basic operator base class.  An abstract class.
 *
 * @author Zack Ives
 * @version 1.0
 */

abstract class Operator {
    Vector _symbols;
    Hashtable _symbolTable;
    
    // Constructor - log the symbol table
    Operator(Hashtable symbolTable) {
        _symbols = null;
        _symbolTable = symbolTable;
    }
    
    // Constructor - save the current symbols
    Operator(Vector symbols, Hashtable symbolTable) {
        _symbols = symbols;
        _symbolTable = symbolTable;
    }
    
    // Datalog variables specified to be used by the operator
    public Vector variables() {
        return _symbols;
    }
    
    // Actual attributes available in the operator
    abstract public Table attribs();
    
    // String representation for printing
    abstract public String toString();
}