import java.util.Vector;
import java.util.Hashtable;


/** Selection operator - apply a predicate
 *
 * @author Zack Ives
 * @version 1.0
 */

class Select extends Operator {
    Operator _child;
    String _pred;
    String _value;
    String _attrib;
    Table _table;
    
    // Constructor - apply a predicate to a variable
    Select(Operator child, String var, String pred, String o, Hashtable symbolTable) {
        super (child.variables(), symbolTable);
        _child = child;
        _pred = pred;
        _value = o;
        
        _attrib = (String)symbolTable.get(var);
        
        // Duplicate the attributes
        _table = new Table("s_" + var + "_" + _value);
        for (int i = 0; i < _child.variables().size(); i++)
            _table.addAttribute(_child.attribs().getAttribute(i));
        

        // Map symbol table entries to our symbols
        for (int i = 0; i < _symbols.size(); i++) {
            _symbolTable.put(_symbols.elementAt(i), attribs().name() + "." + _table.getAttribute(i));
        }
    }

    // String representation
    public String toString() {
        return "Select[" + _attrib + _pred + _value + "](" + _child.toString() + ")";
    }
    
    // Return the attributes
    public Table attribs() {
        return _table;
    }    
}